codeforces 264 B. Good Sequences(dp+数学的一点思想)

题目链接:http://codeforces.com/problemset/problem/264/B

题意:给出一个严格递增的一串数字,求最长的相邻两个数的gcd不为1的序列长度

其实这题可以考虑一下素因数,将每一个数都已是分解为几个不重复的素数,设dp[i]为含有因数i的最长序列有多长

然后遍历一下这串数字,每次更新dp[a[i]]=max(dp[j]+1,dp[a[i]]),j表示a[i]的素因数,再将每个素因数更新为

最大值。

for(int i = 1 ; i <= n ; i++) {

int gg = a[i] , flag = 0 , sum = 0;

MAX = 0;

for(int j = 0 ; j < cnt ; j++) {

flag = 0;

while(gg % num[j] == 0) {

flag = 1;

gg /= num[j];

}

if(flag == 1) {

b[sum++] = num[j];

}

if(gg == 1)//不加这句会超时,因为最后当gg为1的时候就没有1以外的因数了再找下去就是浪费时间

break;

}

for(int j = 0 ; j < sum ; j++) {

MAX = max(dp[b[j]] + 1 , MAX);

}

for(int j = 0 ; j < sum ; j++) {

dp[b[j]] = MAX;

}

}

#include <iostream>
#include <cstring>
#include <cmath>
#include <cstdio>
using namespace std;
const int M = 1e5 + 10;
int a[M] , b[M] , dp[M] , prime[M] , num[M] , cnt = 0;
void IsPrime() {
    prime[0] = prime[1] = 0 , prime[2] = 1;
    for(int i = 3 ; i < M ; i++) {
        prime[i] = i % 2 == 0 ? 0 : 1;
    }
    int t = (int)sqrt(M * 1.0);
    for(int i = 3 ; i <= t ; i++) {
        if(prime[i]) {
            for(int j = i * i ; j < M ; j += 2 * i) {
                prime[j] = 0;
            }
        }
    }
    for(int i = 2 ; i < M ; i++) {
        if(prime[i]) {
            num[cnt++] = i;
        }
    }
}
int main() {
    int n;
    IsPrime();
    scanf("%d" , &n);
    int count = 0 , MAX = 0;
    for(int i = 1 ; i <= n ; i++) {
        scanf("%d" , &a[i]);
    }
    memset(dp , 0 , sizeof(dp));
    for(int i = 1 ; i <= n ; i++) {
        int gg = a[i] , flag = 0 , sum = 0;
        MAX = 0;
        for(int j = 0 ; j < cnt ; j++) {
            flag = 0;
            while(gg % num[j] == 0) {
                flag = 1;
                gg /= num[j];
            }
            if(flag == 1) {
                b[sum++] = num[j];
            }
            if(gg == 1)
                break;
        }
        for(int j = 0 ; j < sum ; j++) {
            MAX = max(dp[b[j]] + 1 , MAX);
        }
        for(int j = 0 ; j < sum ; j++) {
            dp[b[j]] = MAX;
        }
    }
    int MM = 1;
    for(int i = 0 ; i < cnt ; i++) {
        MM = max(dp[num[i]] , MM);
    }
    printf("%d\n" , MM);
    return 0;
}
时间: 2024-10-08 20:18:06

codeforces 264 B. Good Sequences(dp+数学的一点思想)的相关文章

CodeForces 55D Beautiful numbers 数位DP+数学

题意大概是,判断一个正整数区间内有多少个整数能被它自身的每一个非零的数字整除. 因为每一个位置上的整数集s = {0,1,2,3,4,5,6,7,8,9} lcm(s) = 2520 现在有一个整数t是由s中一个或者多个数字构成的,记为abcde,显然t = a*10^4+b*10^3+c*10^2+d*10^1+e 要使得t能被a,b,c,d,e整除,必然有t % lcm(a,b,c,d,e) = 0 因为a,b,c,d,e去重之后一定是s的一个子集,所以lcm(s)一定是lcm(a,b,c,

Codeforces 1144G Two Merged Sequences dp

Two Merged Sequences 感觉是个垃圾题啊, 为什么过的人这么少.. dp[ i ][ 0 ]表示处理完前 i 个, 第 i 个是递增序列序列里的元素,递减序列的最大值. dp[ i ][ 1 ]表示处理完前 i 个, 第 i 个是递减序列序列里的元素,递增序列的最小值. 然后随便转移转移顺便记录一下路径就好啦. #include<bits/stdc++.h> #define LL long long #define fi first #define se second #de

CodeForces 446A DZY Loves Sequences (DP+暴力)

题意:给定一个序列,让你找出一个最长的序列,使得最多改其中的一个数,使其变成严格上升序列. 析:f[i] 表示以 i 结尾的最长上升长度,g[i] 表示以 i 为开始的最长上升长度,这两个很容易就求得,最后枚举中间值即可. 代码如下: #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include <string> #include <cstdlib>

CodeForces 447C DZY Loves Sequences DP

题目:click here 题意:求给定序列更改其中一个元素后的最长连续上升子序列的长度 分析:最长的连续子序列有2种,一种是严格上升(没有更改元素)的长度加1,一种是两段严格上升的加起来.. 1 #include <bits/stdc++.h> 2 using namespace std; 3 #define F first 4 #define S second 5 #define pb push_back 6 #define power(a) ((a)*(a)) 7 #define ENT

codeforces 446A DZY Loves Sequences

codeforces   446A   DZY Loves Sequences         题目链接:http://codeforces.com/problemset/problem/446/A 题目大意:给出一个定长为n的数列a,问改动当中一个数后.可能出现的最长严格上升子段的长度是多少. 题目分析:先不考虑"改动当中一个数"这个条件,这样问题就简单多了,从前到后遍历计数就可以(定义一个数组inc[]长度同a,初始化全部点为1,遍历假设当前点a[i]>a[i-1]就置inc

hdu-5621 KK&#39;s Point(dp+数学)

题目链接: KK's Point Time Limit: 2000/1000 MS (Java/Others)     Memory Limit: 65536/65536 K (Java/Others) Problem Description Our lovely KK has a difficult mathematical problem:He points N(2≤N≤10^5) points on a circle,there are all different.Now he's goi

【矩阵快速幂 】Codeforces 450B - Jzzhu and Sequences (公式转化)

[题目链接]click here~~ [题目大意] Jzzhu has invented a kind of sequences, they meet the following property: You are given x and y, please calculate fn modulo1000000007(109?+?7). [解题思路] /*A - Jzzhu and Sequences Codeforces 450B - Jzzhu and Sequences ( 矩阵快速幂 )

Codeforces 360C Levko and Strings dp

题目链接:点击打开链接 题意: 给定长度为n的字符串s,常数k 显然s的子串一共有 n(n-1)/2 个 要求找到一个长度为n的字符串t,使得t对应位置的k个子串字典序>s #include<stdio.h> #include<iostream> #include<string.h> #include<algorithm> #include<vector> #include<set> using namespace std; #

CodeForces 30C Shooting Gallery 简单dp

题目链接:点击打开链接 给定n个气球 下面n行 x y t val 表示气球出现的坐标(x,y) 出现的时刻t,气球的价值val 枪每秒移动1个单位的距离 问: 射击的最大价值,开始时枪瞄准的位置任意. 思路: dp一下.. #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #include <math.h> #include <set